diff --git a/web/pgadmin/tools/sqleditor/utils/is_begin_required.py b/web/pgadmin/tools/sqleditor/utils/is_begin_required.py
new file mode 100644
index 00000000..8db7b954
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/is_begin_required.py
@@ -0,0 +1,169 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Check if requires BEGIN in the current query."""
+
+
+def is_begin_required(query):
+    word_len = 0
+    query = query.strip()
+    query_len = len(query)
+
+    # Check word length (since "beginx" is not "begin").
+    while (word_len < query_len) and query[word_len].isalpha():
+        word_len += 1
+
+    # Transaction control commands.  These should include every keyword that
+    #  gives rise to a TransactionStmt in the backend grammar, except for the
+    #  savepoint-related commands.
+    #
+    #  (We assume that START must be START TRANSACTION, since there is
+    #  presently no other "START foo" command.)
+
+    keyword = query[0:word_len]
+
+    if word_len == 5 and keyword.lower() == "abort":
+        return False
+    if word_len == 5 and keyword.lower() == "begin":
+        return False
+    if word_len == 5 and keyword.lower() == "start":
+        return False
+    if word_len == 6:
+        # SELECT is protected from dirty reads hence don't require transaction
+        if keyword.lower() in ["select", "commit"]:
+            return False
+    if word_len == 3 and keyword.lower() == "end":
+        return False
+    if word_len == 8 and keyword.lower() == "rollback":
+        return False
+    if word_len == 7 and keyword.lower() == "prepare":
+        # PREPARE TRANSACTION is a TC command, PREPARE foo is not
+        query = query[word_len:query_len]
+        query = query.strip()
+        query_len = len(query)
+        word_len = 0
+
+        while (word_len < query_len) and query[word_len].isalpha():
+            word_len += 1
+
+        keyword = query[0:word_len]
+        if word_len == 11 and keyword.lower() == "transaction":
+            return False
+        return True
+
+    # Commands not allowed within transactions. The statements checked for
+    # here should be exactly those that call PreventTransactionChain() in the
+    # backend.
+    if word_len == 6 and keyword.lower() == "vacuum":
+        return False
+
+    if word_len == 7 and keyword.lower() == "cluster":
+        # CLUSTER with any arguments is allowed in transactions
+        query = query[word_len:query_len]
+        query = query.strip()
+
+        if query[0].isalpha():
+            return True  # has additional words
+        return False  # it's CLUSTER without arguments
+
+    if word_len == 6 and keyword.lower() == "create":
+        query = query[word_len:query_len]
+        query = query.strip()
+        query_len = len(query)
+        word_len = 0
+
+        while (word_len < query_len) and query[word_len].isalpha():
+            word_len += 1
+
+        keyword = query[0:word_len]
+        if word_len == 8 and keyword.lower() == "database":
+            return False
+        if word_len == 10 and keyword.lower() == "tablespace":
+            return False
+
+        # CREATE [UNIQUE] INDEX CONCURRENTLY isn't allowed in xacts
+        if word_len == 7 and keyword.lower() == "cluster":
+            query = query[word_len:query_len]
+            query = query.strip()
+            query_len = len(query)
+            word_len = 0
+
+            while (word_len < query_len) and query[word_len].isalpha():
+                word_len += 1
+
+            keyword = query[0:word_len]
+
+        if word_len == 5 and keyword.lower() == "index":
+            query = query[word_len:query_len]
+            query = query.strip()
+            query_len = len(query)
+            word_len = 0
+
+            while (word_len < query_len) and query[word_len].isalpha():
+                word_len += 1
+
+            keyword = query[0:word_len]
+            if word_len == 12 and keyword.lower() == "concurrently":
+                return False
+        return True
+
+    if word_len == 5 and keyword.lower() == "alter":
+        query = query[word_len:query_len]
+        query = query.strip()
+        query_len = len(query)
+        word_len = 0
+
+        while (word_len < query_len) and query[word_len].isalpha():
+            word_len += 1
+
+        keyword = query[0:word_len]
+
+        # ALTER SYSTEM isn't allowed in xacts
+        if word_len == 6 and keyword.lower() == "system":
+            return False
+        return True
+
+    # Note: these tests will match DROP SYSTEM and REINDEX TABLESPACE, which
+    # aren't really valid commands so we don't care much. The other four
+    # possible matches are correct.
+    if word_len == 4 and keyword.lower() == "drop" \
+            or word_len == 7 and keyword.lower() == "reindex":
+        query = query[word_len:query_len]
+        query = query.strip()
+        query_len = len(query)
+        word_len = 0
+
+        while (word_len < query_len) and query[word_len].isalpha():
+            word_len += 1
+
+        keyword = query[0:word_len]
+        if word_len == 8 and keyword.lower() == "database":
+            return False
+        if word_len == 6 and keyword.lower() == "system":
+            return False
+        if word_len == 10 and keyword.lower() == "tablespace":
+            return False
+        return True
+
+    # DISCARD ALL isn't allowed in xacts, but other variants are allowed.
+    if word_len == 7 and keyword.lower() == "discard":
+        query = query[word_len:query_len]
+        query = query.strip()
+        query_len = len(query)
+        word_len = 0
+
+        while (word_len < query_len) and query[word_len].isalpha():
+            word_len += 1
+
+        keyword = query[0:word_len]
+        if word_len == 3 and keyword.lower() == "all":
+            return False
+        return True
+
+    return True
diff --git a/web/pgadmin/tools/sqleditor/utils/start_running_query.py b/web/pgadmin/tools/sqleditor/utils/start_running_query.py
new file mode 100644
index 00000000..f5e1feae
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/start_running_query.py
@@ -0,0 +1,172 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Start executing the query in async mode."""
+
+import pickle
+import random
+
+from flask import Response
+from flask_babel import gettext
+
+from config import PG_DEFAULT_DRIVER
+from pgadmin.tools.sqleditor.utils.apply_explain_plan_wrapper import apply_explain_plan_wrapper_if_needed
+from pgadmin.tools.sqleditor.utils.update_session_grid_transaction import update_session_grid_transaction
+from pgadmin.tools.sqleditor.utils.is_begin_required import is_begin_required
+from pgadmin.tools.sqleditor.utils.constant_definition import TX_STATUS_IDLE, TX_STATUS_INERROR
+
+from pgadmin.utils.ajax import make_json_response, internal_server_error
+from pgadmin.utils.driver import get_driver
+from pgadmin.utils.exception import ConnectionLost
+
+
+class StartRunningQuery:
+
+    def __init__(self, blueprint_object, logger):
+        self.http_session = None
+        self.blueprint_object = blueprint_object
+        self.connection_id = str(random.randint(1, 9999999))
+        self.logger = logger
+
+    def execute(self, sql, trans_id, http_session):
+        session_obj = StartRunningQuery.retrieve_session_information(http_session, trans_id)
+        if type(session_obj) is Response:
+            return session_obj
+
+        transaction_object = pickle.loads(session_obj['command_obj'])
+        can_edit = False
+        can_filter = False
+        if transaction_object is not None and session_obj is not None:
+            # set fetched row count to 0 as we are executing query again.
+            transaction_object.update_fetched_row_cnt(0)
+            self.__retrieve_connection_id(transaction_object)
+
+            try:
+                manager = get_driver(
+                    PG_DEFAULT_DRIVER).connection_manager(transaction_object.sid)
+                conn = manager.connection(did=transaction_object.did, conn_id=self.connection_id,
+                                          auto_reconnect=False,
+                                          use_binary_placeholder=True,
+                                          array_to_string=True)
+            except ConnectionLost:
+                raise
+            except Exception as e:
+                self.logger.error(e)
+                return internal_server_error(errormsg=str(e))
+
+            # Connect to the Server if not connected.
+            if not conn.connected():
+                status, msg = conn.connect()
+                if not status:
+                    self.logger.error(msg)
+                    return internal_server_error(errormsg=str(msg))
+
+            effective_sql_statement = apply_explain_plan_wrapper_if_needed(manager, sql)
+
+            result, status = self.__execute_query(
+                conn,
+                session_obj,
+                effective_sql_statement,
+                trans_id,
+                transaction_object
+            )
+
+            can_edit = transaction_object.can_edit()
+            can_filter = transaction_object.can_filter()
+
+        else:
+            status = False
+            result = gettext(
+                'Either transaction object or session object not found.')
+        return make_json_response(
+            data={
+                'status': status, 'result': result,
+                'can_edit': can_edit, 'can_filter': can_filter,
+                'info_notifier_timeout': self.blueprint_object.info_notifier_timeout.get()
+            }
+        )
+
+    def __retrieve_connection_id(self, trans_obj):
+        conn_id = trans_obj.conn_id
+        # if conn_id is None then we will have to create a new connection
+        if conn_id is not None:
+            self.connection_id = conn_id
+
+    def __execute_query(self, conn, session_obj, sql, trans_id, trans_obj):
+        if conn.connected():
+            # on successful connection set the connection id to the
+            # transaction object
+            trans_obj.set_connection_id(self.connection_id)
+
+            StartRunningQuery.save_transaction_in_session(session_obj, trans_id, trans_obj)
+
+            # If auto commit is False and transaction status is Idle
+            # then call is_begin_not_required() function to check BEGIN
+            # is required or not.
+
+            if StartRunningQuery.is_begin_required_for_sql_query(trans_obj, conn, sql):
+                conn.execute_void("BEGIN;")
+
+            # Execute sql asynchronously with params is None
+            # and formatted_error is True.
+            try:
+                status, result = conn.execute_async(sql)
+            except ConnectionLost:
+                raise
+
+            # If the transaction aborted for some reason and
+            # Auto RollBack is True then issue a rollback to cleanup.
+            if StartRunningQuery.is_rollback_statement_required(trans_obj, conn):
+                conn.execute_void("ROLLBACK;")
+        else:
+            status = False
+            result = gettext(
+                'Not connected to server or connection with the server has '
+                'been closed.')
+        return result, status
+
+    @staticmethod
+    def is_begin_required_for_sql_query(trans_obj, conn, sql):
+        return not trans_obj.auto_commit \
+               and conn.transaction_status() == TX_STATUS_IDLE \
+               and is_begin_required(sql)
+
+    @staticmethod
+    def is_rollback_statement_required(trans_obj, conn):
+        return conn.transaction_status() == TX_STATUS_INERROR and trans_obj.auto_rollback
+
+    @staticmethod
+    def save_transaction_in_session(session, transaction_id, transaction):
+        # As we changed the transaction object we need to
+        # restore it and update the session variable.
+        session['command_obj'] = pickle.dumps(transaction, -1)
+        update_session_grid_transaction(transaction_id, session)
+
+    @staticmethod
+    def retrieve_session_information(http_session, transaction_id):
+        if 'gridData' not in http_session:
+            return make_json_response(
+                success=0,
+                errormsg=gettext('Transaction ID not found in the session.'),
+                info='DATAGRID_TRANSACTION_REQUIRED', status=404
+            )
+        grid_data = http_session['gridData']
+        # Return from the function if transaction id not found
+        if str(transaction_id) not in grid_data:
+            return make_json_response(
+                success=0,
+                errormsg=gettext('Transaction ID not found in the session.'),
+                info='DATAGRID_TRANSACTION_REQUIRED',
+                status=404
+            )
+        # Fetch the object for the specified transaction id.
+        # Use pickle.loads function to get the command object
+        return grid_data[str(transaction_id)]
+
+
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/__init__.py b/web/pgadmin/tools/sqleditor/utils/tests/__init__.py
new file mode 100644
index 00000000..590026ad
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/tests/__init__.py
@@ -0,0 +1,8 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
diff --git a/web/pgadmin/tools/sqleditor/utils/tests/test_apply_explain_plan_wrapper.py b/web/pgadmin/tools/sqleditor/utils/tests/test_apply_explain_plan_wrapper.py
new file mode 100644
index 00000000..6cf320eb
--- /dev/null
+++ b/web/pgadmin/tools/sqleditor/utils/tests/test_apply_explain_plan_wrapper.py
@@ -0,0 +1,121 @@
+#######################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2018, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+"""Apply Explain plan wrapper to sql object."""
+import sys
+
+from pgadmin.tools.sqleditor.utils import apply_explain_plan_wrapper_if_needed
+from pgadmin.utils.route import BaseTestGenerator
+
+if sys.version_info < (3, 3):
+    from mock import patch, MagicMock
+else:
+    from unittest.mock import patch, MagicMock
+
+
+class StartRunningQueryTest(BaseTestGenerator):
+    """
+    Check that the apply_explain_plan_weapper_if_needed method works as intended
+    """
+    scenarios = [
+        ('When explain_plan is none, it should return unaltered SQL', dict(
+            function_input_parameters={
+                'manager': MagicMock(),
+                'sql': {
+                    'sql': 'some sql',
+                    'explain_plan': None
+                }
+            },
+
+            expect_render_template_mock_parameters=None,
+
+            expected_return_value='some sql'
+        )),
+        ('When explain_plan is not present, it should return unaltered SQL', dict(
+            function_input_parameters={
+                'manager': MagicMock(),
+                'sql': {
+                    'sql': 'some sql'
+                }
+            },
+
+            expect_render_template_mock_parameters=None,
+
+            expected_return_value='some sql'
+        )),
+        ('When explain_plan is present for a Postgres server version 10, it should return SQL with explain plan', dict(
+            function_input_parameters={
+                'manager': MagicMock(version=10, server_type='pg'),
+                'sql': {
+                    'sql': 'some sql',
+                    'explain_plan': {
+                        'format': 'json',
+                        'analyze': False,
+                        'verbose': True,
+                        'buffers': False,
+                        'timing': True
+                    }
+                }
+            },
+
+            expect_render_template_mock_parameters=dict(
+                template_name_or_list='sqleditor/sql/#10#/explain_plan.sql',
+                named_parameters=dict(
+                    format='json',
+                    analyze=False,
+                    verbose=True,
+                    buffers=False,
+                    timing=True
+                )),
+
+            expected_return_value='EXPLAIN (FORMAT JSON, ANALYZE FALSE, VERBOSE TRUE, COSTS FALSE, BUFFERS FALSE, '
+                                  'TIMING TRUE) some sql'
+        )),
+        ('When explain_plan is present for a GreenPlum server version 5, it should return SQL with explain plan', dict(
+            function_input_parameters={
+                'manager': MagicMock(version=80323, server_type='gpdb'),
+                'sql': {
+                    'sql': 'some sql',
+                    'explain_plan': {
+                        'format': 'json',
+                        'analyze': False,
+                        'verbose': True,
+                        'buffers': False,
+                        'timing': True
+                    }
+                }
+            },
+
+            expect_render_template_mock_parameters=dict(
+                template_name_or_list='sqleditor/sql/#gpdb#80323#/explain_plan.sql',
+                named_parameters=dict(
+                    format='json',
+                    analyze=False,
+                    verbose=True,
+                    buffers=False,
+                    timing=True
+                )),
+
+            expected_return_value='EXPLAIN some sql'
+        ))
+    ]
+
+    def runTest(self):
+        with patch('pgadmin.tools.sqleditor.utils.apply_explain_plan_wrapper.render_template') as render_template_mock:
+            render_template_mock.return_value = self.expected_return_value
+            result = apply_explain_plan_wrapper_if_needed(**self.function_input_parameters)
+            self.assertEquals(result, self.expected_return_value)
+            if self.expect_render_template_mock_parameters:
+                render_template_mock.assert_called_with(
+                    self.expect_render_template_mock_parameters['template_name_or_list'],
+                    sql=self.function_input_parameters['sql']['sql'],
+                    **self.expect_render_template_mock_parameters['named_parameters']
+                )
+            else:
+                render_template_mock.assert_not_called()
